/****************************************************************************
 * Ce programme fait partie du projet Multiserveur.                         *
 * (C) Nicolas GEORGE, aot 1998.                                           *
 * Vous devriez trouver les termes de sa license pas trs loin.             *
 * Je dcline toute responsabilit quant  l'effet de ce programme.         *
 ****************************************************************************/

/**********************************************
  Accepte les connexions et lance les guichets
 **********************************************/

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <signal.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "config.h"
#include "connect.h"
#include "guichet.h"
#include "multiserv.h"

static int serv_fd;
static char phcmpl[]=PHRASE_COMPLET;
static short loop=1;

static void mort_serveur(int s)
{
  loop=0;
}

static int attendre_mort(void)
{
  int i,j;

  for(i=0;i<50;i++){
    for(j=0;j<MAXCLI;j++)
      if(client[j].pid!=0)
	break;
    if(j==MAXCLI)
      return(0);
    usleep(1000);
  }
  return(0);
}

void boucle_attente_connexions(void)
{
  struct sockaddr_in as,ac;
  int p,r,l;
  pid_t f;

  for(p=PORT;p<=MAXPORT;p++){
    serv_fd=socket(AF_INET,SOCK_STREAM,0);
    bzero((char *)&as,sizeof(as));
    as.sin_family=AF_INET;
    as.sin_port=htons(p);
    as.sin_addr.s_addr=htonl(INADDR_ANY);
    if(bind(serv_fd,(struct sockaddr *)&as,sizeof(as))==0)
      break;
  }
  if(p>MAXPORT){
    /* Foutre la merde */
    return;
  }
  lprintf("Connexion tablie sur le port %d\n",p);
  listen(serv_fd,5);
  fcntl(serv_fd,F_SETFL,O_NONBLOCK);

  signal(SIGTERM,mort_serveur);
  signal(SIGINT,mort_serveur);
  while(loop){
    l=sizeof(ac);
    r=accept(serv_fd,(struct sockaddr *)&ac,&l);
    if(r>=0){
      {
	unsigned char *adr;

	l=sizeof(ac);
	getpeername(r,(struct sockaddr *)&ac,&l);
	adr=(unsigned char *)&ac.sin_addr.s_addr;
	lprintf("Connexion de %d.%d.%d.%d\n",adr[0],adr[1],adr[2],adr[3]);
      }
      fcntl(r,F_SETFL,O_NONBLOCK);
      for(p=0;p<MAXCLI;p++)
	if(client[p].pid==0)
	  break;
      if(p==MAXCLI){
	write(r,phcmpl,sizeof(phcmpl));
	shutdown(r,2);
	close(r);
	lprintf("Connexion refuse\n");
      }else{
	lprintf("Connexion attribue au client %d\n",p);
	if((f=fork())==0){
	  ouvrir_guichet(r,p);
	  return;
	}
	close(r);
	client[p].pid=f;
      }
    }
    usleep(10000);
  }
  close(serv_fd);

  if(attendre_mort()){
    for(l=0;l<MAXCLI;l++)
      if(client[l].pid!=0)
	kill(client[l].pid,SIGTERM);
    if(attendre_mort()){
      for(l=0;l<MAXCLI;l++)
	if(client[l].pid!=0)
	  kill(client[l].pid,SIGTERM);
    }
  }
}
