/****************************************************************************
 * Ce programme fait partie du projet Multiserveur.                         *
 * (C) Nicolas GEORGE, aot 1998.                                           *
 * Vous devriez trouver les termes de sa license pas trs loin.             *
 * Je dcline toute responsabilit quant  l'effet de ce programme.         *
 ****************************************************************************/

/*********************************************
  Gre le dialogue avec un client particulier
 *********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <unistd.h>
#include <ctype.h>
#include <ncurses.h>
#include <term.h>
#include <sys/socket.h>
#include <arpa/telnet.h>
#include "config.h"
#include "multiserv.h"
#include "guichet.h"
#include "events.h"

typedef struct {
  unsigned char *s;
  short k;
} description_touche;

static int fd,nc;
static unsigned char *rdbuf,*wrbuf;
static int wrpos,wrsnt;
static int lterm,hterm;
static short etat;
static unsigned char *tdesc=NULL;
description_touche *key;
static int ptd,nkey;
static int rechh,rechb,rechn,rechd;
static unsigned char *tibel,*ticlear,*ticup,*tisetf,*tisetb;
static unsigned short *ecran=NULL,attr,curecr;

static const struct { unsigned char **v,*n; } caplist[]={
  {&ticup  ,"cup"  },{&ticlear,"clear"},
  {&tisetf, "setf" },{&tisetb, "setb" },
  {&tibel,  "bel"  },
};
static const struct { short k; unsigned char n[6]; } keylist[]={
  {K_F(1)     ,"kf1"  },{K_F(2)     ,"kf2"  },{K_F(3)     ,"kf3"  },{K_F(4)     ,"kf4"  },
  {K_F(5)     ,"kf5"  },{K_F(6)     ,"kf6"  },{K_F(7)     ,"kf7"  },{K_F(8)     ,"kf8"  },
  {K_BACKSPACE,"kbs"  },{13         ,"kent" },{K_INSERT   ,"kich1"},{K_DELETE   ,"kdch1"},
  {K_HOME     ,"khome"},{K_END      ,"kend" },{K_PGUP     ,"knp"  },{K_PGDN     ,"kpp"  },
  {K_UP       ,"kcuu1"},{K_DOWN     ,"kcud1"},{K_LEFT     ,"kcub1"},{K_RIGHT    ,"kcuf1"},
  {13         ,"cr"   },
};
const description_touche defkey[]={
  {"\033OP",  K_F(1) },{"\033OQ",  K_F(2) },{"\033OR",  K_F(3) },{"\033OS",  K_F(4) },
  {"\033Op",  K_F(5) },{"\033Oq",  K_F(6) },{"\033Or",  K_F(7) },{"\033Os",  K_F(8) },
  {"\033OA",  K_UP   },{"\033OB",  K_DOWN },{"\033OC",  K_RIGHT},{"\033OD",  K_LEFT },
  {"\033[4J", K_PGUP },{"\033[3J", K_PGDN },{"\033[2J", K_HOME },{"\033[N",  K_END  },
  {"\033[=a", K_F(1) },{"\033[=b", K_F(2) },{"\033[=c", K_F(3) },{"\033[=d", K_F(4) },
  {"\033[=e", K_F(5) },{"\033[=f", K_F(6) },{"\033[=g", K_F(7) },{"\033[=h", K_F(8) },
  {"\033[A",  K_UP   },{"\033[B",  K_DOWN },{"\033[C",  K_RIGHT},{"\033[D",  K_LEFT },
  {"\033A",   K_UP   },{"\033B",   K_DOWN },{"\033C",   K_RIGHT},{"\033D",   K_LEFT },
  {"\033?r",  K_DOWN },{"\033?t",  K_LEFT },{"\033?v",  K_RIGHT},{"\033?x",  K_UP   },
  {"\033\033",27     },{"\001",    K_HOME },{"\005",    K_END  },
};

static void ajouter_touche(short k,unsigned char *t)
{
  int i;

  for(i=0;t[i]!=0;i++);
  i++;
  if(ptd+i>65536){
    /*printf("Terminal trop complexe, chanes ignores\n");*/
    return;
  }
  key[nkey].k=k;
  key[nkey].s=(unsigned char *)ptd;
  nkey++;
  for(;i>0;i--)
    tdesc[ptd++]=*(t++);
}

static int strcmpptr(const void *a,const void *b)
{
  return(strcmp(((description_touche *)a)->s,
		((description_touche *)b)->s));
}

static inline int telputchar(int c)
{
  if((wrpos+1)%WRITE_BUF_SIZE!=wrsnt){
    wrbuf[wrpos++]=c;
    wrpos%=WRITE_BUF_SIZE;
  }else{
#define DEBUG
#ifdef DEBUG
    printf("\aBuffer d'mission satur\n");
    fflush(stdout);
    /* else foutre la merde */
#endif
  }
  return(0);
}

static void changer_type_terminal(char *t)
{
  unsigned char *b;
  int i,j;

  if(tdesc!=NULL)
    free(tdesc);
  tdesc=malloc(65536);
  nkey=0;
  key=(description_touche *)tdesc;
  ptd=(sizeof(keylist)/sizeof(*keylist)+sizeof(defkey)/sizeof(*defkey))
    *sizeof(description_touche);
  if(setupterm(t,fd,NULL))
    setupterm(DEFAULTTERM,fd,NULL);
  for(i=0;i<sizeof(keylist)/sizeof(*keylist);i++){
    b=tigetstr(keylist[i].n);
    if(b!=NULL)
      ajouter_touche(keylist[i].k,b);
  }
  for(i=0;i<sizeof(defkey)/sizeof(*defkey);i++)
    ajouter_touche(defkey[i].k,defkey[i].s);

  for(i=0;i<sizeof(caplist)/sizeof(*caplist);i++){
    b=tigetstr(caplist[i].n);
    if((b==NULL)||(b==(void*)-1)){
      *(caplist[i].v)=NULL;
    }else{
      for(j=0;b[j]!=0;j++);
      j++;
      if(ptd+j>65536)
	*(caplist[i].v)=NULL;
      else{
	*(caplist[i].v)=(unsigned char *)ptd;
	for(j=0;b[j]!=0;j++)
	  tdesc[ptd++]=b[j];
	tdesc[ptd++]=0;
      }
    }
  }

  tdesc=realloc(tdesc,ptd);

  for(i=0;i<sizeof(caplist)/sizeof(*caplist);i++)
    if(*(caplist[i].v)!=NULL)
      *(caplist[i].v)=tdesc+(int)(*(caplist[i].v));

  for(i=0;i<nkey;i++)
    key[i].s=tdesc+(int)key[i].s;
  qsort(key,nkey,sizeof(description_touche),strcmpptr);
  for(i=j=0;i<nkey;i++)
    if((i==0)||(strcmp(key[i-1].s,key[i].s)))
      key[j++]=key[i];
  nkey=j;
  rechb=0;
  rechh=nkey-1;
  rechd=-1;
  rechn=0;
}

static void initialiser_telnet(void)
{
  static char ctrl[]={IAC,DO,TELOPT_LINEMODE,
		      IAC,WILL,TELOPT_ECHO,
		      IAC,DO,TELOPT_BINARY,
		      IAC,DO,TELOPT_TTYPE,
		      IAC,SB,TELOPT_TTYPE,TELQUAL_SEND,IAC,SE,
		      IAC,DO,TELOPT_NAWS};
  etat=0;
  rdbuf=malloc(READ_BUF_SIZE+WRITE_BUF_SIZE);
  wrbuf=rdbuf+READ_BUF_SIZE;

  lterm=80;
  hterm=25;
  for(wrpos=0;wrpos<sizeof(ctrl);wrpos++)
    wrbuf[wrpos]=ctrl[wrpos];
  wrsnt=0;
}

static int lire_telnet(int d)
{
  static unsigned char tt[4];
  static char ttype[TTYPE_MAX+1];
  static short ttypep=0;

  switch(etat){
    case 0: /* Etat fondamental */
      if(d==IAC) etat=1;
      else return(d);
      break;
    case 1: /* Attente de commande */
      if(d==SB) etat=3;
      else if((d==DO)||(d==DONT)||(d==WILL)||(d==WONT))
	etat=2;
      else etat=0;
      break;
    case 2: /* Attente d'option */
      etat=0;
      break;
    case 3: /* Dbut de sous-ngociation */
      if(d==TELOPT_NAWS) etat=6;
      else if(d==TELOPT_TTYPE) etat=16;
      else etat=4;
      break;
    case 4: /* Milieu de sous-ngociation */
      if(d==IAC) etat=5;
      break;
    case 5: /* Fin de sous-ngociation */
      if(d==SE) etat=0;
      else etat=4;
      break;
    case 6: /* Taille 1 */
      tt[0]=d;
      if(d==IAC) etat=7;
      else etat=8;
      break;
    case 8: /* Taille 2 */
      tt[1]=d;
      if(d==IAC) etat=9;
      else etat=10;
      break;
    case 10: /* Taille 3 */
      tt[2]=d;
      if(d==IAC) etat=11;
      else etat=12;
      break;
    case 12: /* Taille 4 */
      tt[3]=d;
      if(d==IAC) etat=13;
      else etat=14;
      break;
    case 7: /* Taille 1' */
    case 9: /* Taille 2' */
    case 11: /* Taille 3' */
    case 13: /* Taille 4' */
      if(d==IAC) etat++;
      else etat=0;
      break;
    case 14: /* Fin de taille */
      if(d==IAC) etat=15;
      break;
    case 15: /* Fin de sous-ngociation de taille */
      if(d==SE){
	lterm=(((int)tt[0])<<8)|((int)tt[1]);
	hterm=(((int)tt[2])<<8)|((int)tt[3]);
	etat=0;
	return(TAILLE);
      }else
	etat=14;
      break;
    case 16: /* Type de terminal */
      if(d==TELQUAL_IS){
	ttypep=0;
	etat=17;
      }
      else etat=4;
      break;
    case 17:
      if(d==IAC) etat=18;
      else
	if(ttypep<TTYPE_MAX)
	  ttype[ttypep++]=tolower(d);
      break;
    case 18: /* Fin de sous-ngociation */
      if(d==SE){
	etat=0;
	ttype[ttypep++]=0;
	changer_type_terminal(ttype);
      }
      else d=17;
      break;
  }
  return(RIEN);
}

static int decoder_touche(int t)
{
  t=(unsigned char)t;
  while((rechb<nkey)&&(key[rechb].s[rechn]<t))
    rechb++;
  while((rechh>=0)&&(key[rechh].s[rechn]>t))
    rechh--;
  if(rechb>rechh){
    if(rechd==-1){
      if(rechn!=0)
	t=RIEN;
    }else
      t=key[rechd].k;
    rechb=0;
    rechh=nkey-1;
    rechn=0;
    rechd=-1;
    return(t);
  }
  rechn++;
  if((rechb<nkey)&&(key[rechb].s[rechn]==0))
    rechd=rechb;
  if(rechd==rechh){
    t=key[rechd].k;
    rechb=0;
    rechh=nkey-1;
    rechn=0;
    rechd=-1;
    return(t);
  }
  return(RIEN);
}

void reinitialiser_client(int c)
{
  client[c].pid=0;
  client[c].insh=client[c].inst=client[c].inss=0;
  client[c].keyh=client[c].keyt=client[c].keys=0;
}

void g_effacer_ecran(void)
{
  int i,j;

  tputs(ticlear,1,telputchar);
  /* rafraichissement */
  j=lterm*hterm;
  for(i=0;i<j;i++)
    ecran[i]=attr;
}

void g_fixer_attributs(int a)
{
  a<<=8;
  if(((a^attr)&0xF000)!=0)
    tputs(tparm(tisetb,a>>12),1,telputchar);
  if(((a^attr)&0x0F00)!=0)
    tputs(tparm(tisetf,(a>>8)&15),1,telputchar);
  attr=a;
}

void g_fixer_position(int x,int y)
{
  curecr=x+y*lterm;
  tputs(tparm(ticup,y,x),1,telputchar);
}

void g_ecrire_chaine(char *s)
{
  for(;*s!=0;s++){
    telputchar(*s);
    ecran[curecr++]=attr|(unsigned short)(*s);
    /*if(curecr==lterm*hterm)
      printf("Alarme: bord de l'cran\n");*/
  }
}

void g_sonner_terminal(void)
{
  tputs(tibel,1,telputchar);
}

void envoyer_touche(int nc,int c)
{
  int i=0;

  while(client[nc].keys==KEY_BUF_SIZE){
    usleep(1000);
    if(i++==20){
      g_sonner_terminal();
      return;
    }
  }
  client[nc].key[client[nc].keyh++]=c;
  client[nc].keyh%=KEY_BUF_SIZE;
  client[nc].keys++;
}

void ouvrir_guichet(int f,int ncl)
{
  int l,i,c,j,k;

  fd=f;
  nc=ncl;
  initialiser_telnet();

  while(1){
    usleep(10000);
    l=read(fd,rdbuf,READ_BUF_SIZE);
    if(l==0)
      break;
    for(i=0;i<l;i++){
      c=lire_telnet(rdbuf[i]);
      switch(c){
	case RIEN:
	  break;
	case TAILLE:
	  if(ecran!=NULL)
	    free(ecran);
	  if(lterm>LTERMMAX) lterm=LTERMMAX;
	  if(hterm>HTERMMAX) hterm=HTERMMAX;
	  k=lterm*hterm;
	  ecran=malloc(k*sizeof(unsigned short));
	  for(j=0;j<k;j++)
	    ecran[j]=attr;
	  envoyer_touche(nc,TAILLE);
	  envoyer_touche(nc,lterm);
	  envoyer_touche(nc,hterm);
	  break;
	default:
	  if(tdesc==NULL)
	    break;
	  c=decoder_touche(c);
	  if(c!=RIEN)
	    envoyer_touche(nc,c);
	  break;
      }
    }

    if(wrsnt!=wrpos){
      l=write(fd,wrbuf+wrsnt,wrsnt<wrpos?wrpos-wrsnt:WRITE_BUF_SIZE-wrsnt);
      wrsnt+=l;
      wrsnt%=WRITE_BUF_SIZE;
    }
    while(client[nc].inss){
      l=client[nc].ins[client[nc].inst++];
      client[nc].inst%=INSTR_BUF_SIZE;
      client[nc].inss--;
      switch(l){
	case P_CLEAR:
	  g_effacer_ecran();
	  break;
	case P_ATTR:
	  i=(unsigned char)client[nc].ins[client[nc].inst++];
	  client[nc].inst%=INSTR_BUF_SIZE;
	  client[nc].inss--;
	  g_fixer_attributs(i);
	  break;
	case P_LOCATE:
	  i=(unsigned char)client[nc].ins[client[nc].inst++];
	  client[nc].inst%=INSTR_BUF_SIZE;
	  client[nc].inss--;
	  i|=((int)(unsigned char)client[nc].ins[client[nc].inst++])<<8;
	  client[nc].inst%=INSTR_BUF_SIZE;
	  client[nc].inss--;
	  i|=((int)(unsigned char)client[nc].ins[client[nc].inst++])<<16;
	  client[nc].inst%=INSTR_BUF_SIZE;
	  client[nc].inss--;
	  g_fixer_position(i&4095,i>>12);
	  break;
	case P_PRINT:
	  while(1){
	    i=(unsigned char)client[nc].ins[client[nc].inst++];
	    client[nc].inst%=INSTR_BUF_SIZE;
	    client[nc].inss--;
	    if(i==0) break;
	    telputchar(i);
	  }
	  break;
	case P_BEEP:
	  g_sonner_terminal();
	  break;
	case P_SHUT:
	  shutdown(fd,2);
	  break;
      }
    }
  }
}
