/****************************************************************************
 * Ce programme fait partie du projet Multiserveur.                         *
 * (C) Nicolas GEORGE, aot 1998.                                           *
 * Vous devriez trouver les termes de sa license pas trs loin.             *
 * Je dcline toute responsabilit quant  l'effet de ce programme.         *
 ****************************************************************************/

/************************
  Un squelette de module
 ************************/

#include <stdio.h>
#include <malloc.h>
#include <unistd.h>
#include <string.h>
#include "config.h"
#include "module.h"
#include "events.h"
#include "multiserv.h"

#define MAXUSR 8
#define BUFSIZE 2048
#define C(c) ((module_chat_info *)(c))

const module_class_info module_chat_class;

typedef struct {
  short u;
  short x[MAXUSR],y[MAXUSR];
  short o,o0[MAXUSR];
  char buf[BUFSIZE];
} module_chat_utilisateur_info;

typedef struct {
  module_info mod;
  module_chat_utilisateur_info *u[MAXUSR];
  short nu;
  /* le reste */
} module_chat_info;

static module_info *module_chat_new(void)
{
  module_chat_info *r;

  r=malloc(sizeof(module_chat_info));
  r->mod.timer=-1;
  r->mod.class=&module_chat_class;
  r->nu=0;
  return(&r->mod);
}

static void module_chat_destroy(module_info *m)
{
  int i;

  for(i=0;i<C(m)->nu;i++)
    free(C(m)->u[i]);
  free(m);
}

static void passer_ligne(module_chat_utilisateur_info *u,int l,int ca)
{
  int x;

  for(x=0;x<l;x++){
    if(u->buf[u->o0[ca]++]=='\n')
      break;
    if(u->o0[ca]==BUFSIZE)
      u->o0[ca]=0;
  }
  if(u->o0[ca]==BUFSIZE)
    u->o0[ca]=0;
}

static void afficher_zone(module_chat_info *m,int cz,int ca)
{
  char *b;
  int o,of,x,y,l,h,y0;

  of=m->u[cz]->o;
  x=y=0;
  b=m->u[cz]->buf;
  l=clipriv[m->u[ca]->u].l;
  for(o=m->u[cz]->o0[ca];o!=of;o=(o+1)%BUFSIZE){
    if(b[o]=='\n'){
      x=0;
      y++;
    }else
      if(++x==l){
	x=0;
	y++;
      }
  }
  y0=2+cz*(clipriv[m->u[ca]->u].h-2)/m->nu;
  h=1+(cz+1)*(clipriv[m->u[ca]->u].h-2)/m->nu-y0;
  for(;y>=h;y--)
    passer_ligne(m->u[cz],l,ca);
  m->u[cz]->x[ca]=x;
  m->u[cz]->y[ca]=y;
  x=y=0;
  h=m->u[ca]->u;
  attributs(h,0x70);
  for(o=m->u[cz]->o0[ca];o!=of;o=(o+1)%BUFSIZE){
    if(x==0){
      position(h,0,y+y0);
      ecrire_deb(h,l);
    }
    if(b[o]=='\n')
      for(;x<l;x++){
	ECRIRE(h,' ');
      }
    else{
      ECRIRE(h,b[o]);
      x++;
    }
    if(x==l){
      ecrire_fin(h,l);
      x=0;
      y++;
    }
  }
  if(x==0){
    position(h,0,y+y0);
    ecrire_deb(h,l);
  }
  for(o=x;o<l;o++){
    ECRIRE(h,' ');
  }
  ecrire_fin(h,l);
  position(h,x,y+y0);
}

static void ajouter_caractere(module_chat_info *m,int u,int c)
{
  int i;

  m->u[u]->buf[m->u[u]->o++]=c;
  if(m->u[u]->o==BUFSIZE)
    m->u[u]->o=0;
  for(i=0;i<MAXUSR;i++)
    if(m->u[u]->o0[i]==m->u[u]->o){
      if(i<m->nu)
	passer_ligne(m->u[u],clipriv[m->u[c]->u].l,i);
      else
	m->u[u]->o0[i]++;
    }
}

static void module_chat_event(module_info *m,int c,int e,void *p)
{
  int i,j,k,l,h,x,y,c2,n;

  n=C(m)->nu;
  if(e==E_ENTRE){
    if(n==MAXUSR){
      effacer(c);
      ecrire(c,"C'est complet");
      return;
    }
    C(m)->u[n]=malloc(sizeof(module_chat_utilisateur_info));
    C(m)->u[n]->u=c;
    for(j=0;j<MAXUSR;j++)
      C(m)->u[n]->x[j]=C(m)->u[n]->y[j]=C(m)->u[n]->o0[j]=0;
    C(m)->u[n]->o=0;
    for(j=0;j<BUFSIZE;j++)
      C(m)->u[n]->buf[j]='\n';
    C(m)->nu++;
    for(j=0;j<C(m)->nu;j++)
      module_chat_event(m,C(m)->u[j]->u,TAILLE,NULL);
    return;
  }
  for(i=0;i<n;i++)
    if(C(m)->u[i]->u==c)
      break;
  if(i==n)
    return;
  if(trop_petit(c,40,2+2*C(m)->nu,&l,&h))
    return;

  if(e==TAILLE){
    effacer(c);
    attributs(c,0x70);
    for(j=0;j<n;j++){
      c2=C(m)->u[j]->u;
      position(c,0,1+(h-2)*j/n);
      for(x=0;clipriv[c2].nom[x]!=0;x++);
      y=(l-x)>>1;
      ecrire_deb(c,l);
      for(k=0;k<y-1;k++) ECRIRE(c,'=');
      ECRIRE(c,' ');
      for(k=0;k<x;k++)
	ECRIRE(c,clipriv[c2].nom[k]);
      ECRIRE(c,' ');
      for(k=x+y+1;k<l;k++) ECRIRE(c,'=');
      ecrire_fin(c,l);
      afficher_zone(C(m),j,i);
    }

  }else if(e==E_SORT){
    free(C(m)->u[i]);
    for(j=i+1;j<MAXUSR;j++)
      C(m)->u[j-1]=C(m)->u[j];
    C(m)->u[MAXUSR-1]=NULL;
    C(m)->nu--;
    for(j=0;j<C(m)->nu;j++)
      module_chat_event(m,C(m)->u[j]->u,TAILLE,NULL);
    if(C(m)->nu==0)
      detruire_module_ptr(m);
    return;

  }else if(e==13){
    ajouter_caractere(C(m),i,'\n');
    for(j=0;j<n;j++){
      k=C(m)->u[j]->u;
      C(m)->u[i]->x[j]=0;
      C(m)->u[i]->y[j]++;
      y=i*(clipriv[k].h-2)/n+1;
      if(C(m)->u[i]->y[j]==(i+1)*(clipriv[k].h-2)/n-y)
	afficher_zone(C(m),i,j);
      position(k,C(m)->u[i]->x[j],y+1+C(m)->u[i]->y[j]);
    }

  }else if(e==7){
    for(j=0;j<n;j++){
      k=C(m)->u[j]->u;
      y=i*(clipriv[k].h-2)/n+1;
      position(k,C(m)->u[i]->x[j],y+1+C(m)->u[i]->y[j]);
      sonner(k);
    }

  }else if(e==K_BACKSPACE){
    if(C(m)->u[i]->o--==0)
      C(m)->u[i]->o=BUFSIZE-1;
    C(m)->u[i]->buf[C(m)->u[i]->o]='\n';
    for(j=0;j<n;j++){
      c2=C(m)->u[j]->u;
      x=--C(m)->u[i]->x[j];
      y=C(m)->u[i]->y[j];
      if(x<0){
	y--;
	for(k=(C(m)->u[i]->o+BUFSIZE-1)%BUFSIZE;C(m)->u[i]->buf[k]!='\n';
	    k=(k+BUFSIZE-1)%BUFSIZE);
	x=((C(m)->u[i]->o-k-1+BUFSIZE)%BUFSIZE)%clipriv[c2].l;
	C(m)->u[i]->x[j]=x;
	C(m)->u[i]->y[j]=y;
	if(y<0){
	  C(m)->u[i]->x[j]=y++;
	  C(m)->u[i]->o0[j]+=BUFSIZE-x-1;
	  C(m)->u[i]->o0[j]%=BUFSIZE;
	  afficher_zone(C(m),i,j);
	  continue;
	}
      }
      y+=i*(clipriv[c2].h-2)/n+2;
      position(c2,x,y);
      attributs(c2,0x70);
      ecrire_n_fois(c2,' ',1);
      position(c2,x,y);
    }
    for(;j<MAXUSR;j++)
      if((C(m)->u[i]->o+1)%BUFSIZE==C(m)->u[i]->o0[j])
	if(--C(m)->u[i]->o0[j]<0)
	  C(m)->u[i]->o0[j]+=BUFSIZE;

  }else if((e>=32)&&(e<=254)){
    ajouter_caractere(C(m),i,e);
    for(j=0;j<n;j++){
      k=C(m)->u[j]->u;
      attributs(k,0x70);
      y=i*(clipriv[k].h-2)/n+1;
      position(k,C(m)->u[i]->x[j]++,y+1+C(m)->u[i]->y[j]);
      ecrire_n_fois(k,e,1);
      if(C(m)->u[i]->x[j]==clipriv[k].l){
	C(m)->u[i]->x[j]=0;
	C(m)->u[i]->y[j]++;
	if(C(m)->u[i]->y[j]==(i+1)*(clipriv[k].h-2)/n-y)
	  afficher_zone(C(m),i,j);
	position(k,C(m)->u[i]->x[j],y+1+C(m)->u[i]->y[j]);
      }
    }
  }
}

static void module_chat_describe(module_info *m,int c,char *b)
{
  strcpy(b,"Salle de discussion");
}

const module_class_info module_chat_class={
  0,1,
  1L,
  module_chat_new,
  module_chat_destroy,
  module_chat_event,
  module_chat_describe
};
