/****************************************************************************
 * Ce programme fait partie du projet Multiserveur.                         *
 * (C) Nicolas GEORGE, aot 1998.                                           *
 * Vous devriez trouver les termes de sa license pas trs loin.             *
 * Je dcline toute responsabilit quant  l'effet de ce programme.         *
 ****************************************************************************/

/************************
  Un squelette de module
 ************************/

#include <stdio.h>
#include <malloc.h>
#include <unistd.h>
#include <time.h>
#include "config.h"
#include "module.h"
#include "events.h"
#include "multiserv.h"

#define C(c) ((module_forum_info *)(c))

const module_class_info module_forum_class;

#define MAXMSGLEN 320
#define ALLLEN 16384

typedef struct {
  int x,x0,l;
  char b[320];
} module_forum_utilisateur_info;

typedef struct {
  module_info mod;
  time_t der;
  char b[ALLLEN];
  module_forum_utilisateur_info *u[MAXCLI];
} module_forum_info;

static module_info *module_forum_new(void)
{
  module_forum_info *r;
  int i;

  r=malloc(sizeof(module_forum_info));
  r->mod.timer=-1;
  r->mod.class=&module_forum_class;
  for(i=0;i<MAXCLI;i++)
    r->u[i]=NULL;
  r->b[0]=0;
  r->der=-1L;
  return(&r->mod);
}

static void module_forum_destroy(module_info *m)
{
  int i;

  for(i=0;i<MAXCLI;i++)
    if(C(m)->u[i]!=NULL)
      free(C(m)->u[i]);
  free(m);
}

static void dessiner_entree(module_forum_info *m,int c,int l,int h)
{
  int i,j;
  char *b;

  position(c,1,h-2);
  attributs(c,0x60);
  b=m->u[c]->b+m->u[c]->x0;
  j=m->u[c]->l-m->u[c]->x0;
  if(j>l-2) j=l-2;
  ecrire_deb(c,l-2);
  for(i=0;i<j;i++)
    ECRIRE(c,*(b++));
  for(;i<l-2;i++)
    ECRIRE(c,' ');
  ecrire_fin(c,l-2);
  position(c,1+m->u[c]->x-m->u[c]->x0,h-2);
}

static void dessiner_ecran(module_forum_info *m,int c,int l,int h)
{
  int x,y=2,i,j;
  char *b,*s;

  attributs(c,0x70);
  effacer(c);
  position(c,(l-5)>>1,1);
  ecrire(c,"Forum");

  b=m->b;
  while((y<h-2)&&(*b!=0)){
    x=0;
    position(c,0,y);
    attributs(c,0x71);
    for(s=b,i=0;*s!='\n';s++,i++);
    s++;
    ecrire_deb(c,i+2);
    for(j=0;j<i;j++){
      ECRIRE(c,*(b++));
      x++;
    }
    b++;
    ECRIRE(c,':');
    ECRIRE(c,' ');
    x+=2;
    ecrire_fin(c,i+2);

    attributs(c,0x70);
    for(s=b,i=0;*s!=0;s++,i++);
    while((*b!=0)&&(y<h-2)){
      position(c,x,y);
      ecrire_max(c,b,l-x);
      j=i<l-x?i:l-x;
      b+=j;
      i-=j;
      x=0;
      y++;
    }
    b++;
  }
  if(m->der>=0L){
    char b[40];
    struct tm *t;

    t=localtime(&m->der);
    sprintf(b,"Dernier message: %2.2d/%2.2d/%4.4d %2.2d:%2.2d:%2.2d",
	    t->tm_mday,t->tm_mon+1,t->tm_year+1900,t->tm_hour,t->tm_min,t->tm_sec);
    position(c,0,h-1);
    ecrire(c,b);
  }

  dessiner_entree(m,c,l,h);
}

static void modifier_texte(module_forum_info *m,int c,int l,int h,int x)
{
  int i;

  if(m->u[c]->x-m->u[c]->x0>=l-2){
    m->u[c]->x0+=(l-2)>>1;
    dessiner_entree(m,c,l,h);
  }else if(m->u[c]->x<m->u[c]->x0){
    m->u[c]->x0-=(l-2)>>1;
    if(m->u[c]->x0<0) m->u[c]->x0=0;
    dessiner_entree(m,c,l,h);
  }else{
    position(c,1+x-C(m)->u[c]->x0,h-2);
    attributs(c,0x60);
    i=m->u[c]->x0+l-2;
    if(m->u[c]->l<i) i=m->u[c]->l;
    ecrire_max(c,m->u[c]->b+x,i-x);
    if(i!=m->u[c]->x-x)
      position(c,1+C(m)->u[c]->x-C(m)->u[c]->x0,h-2);
  }
}

static void ajouter_message(module_forum_info *m,int c)
{
  int i,j;
  char *b,*s;

  for(j=0;clipriv[c].nom[j]!=0;j++);
  j+=2+m->u[c]->l;

  b=m->b;
  i=0;
  for(s=b;*s!=0;){
    for(;*s!=0;s++)
      i++;
    s++;
    i++;
  }
  while(i+j>ALLLEN)
    for(s--,i--;s[-1]!=0;s--,i--);
  *s=0;
  for(;i>=0;i--,s--)
    s[j]=*s;
  for(s=clipriv[c].nom;*s!=0;s++,b++)
    *b=*s;
  *(b++)='\n';
  s=m->u[c]->b;
  for(i=m->u[c]->l;i>0;i--,s++,b++)
    *b=*s;
  *(b++)=0;

  time(&m->der);

  m->u[c]->x=m->u[c]->x0=m->u[c]->l=0;
  for(i=0;i<MAXCLI;i++)
    if(m->u[i]!=NULL)
      dessiner_ecran(m,i,clipriv[i].l,clipriv[i].h);
}

static void module_forum_event(module_info *m,int c,int e,void *p)
{
  int l,h;
  int i,x;
  char *b;

  if(trop_petit(c,40,16,&l,&h))
    return;

  switch(e){
    case E_ENTRE:
      C(m)->u[c]=malloc(sizeof(module_forum_utilisateur_info));
      C(m)->u[c]->x=C(m)->u[c]->x0=C(m)->u[c]->l=0;

    case TAILLE:
      if(C(m)->u[c]->x>=C(m)->u[c]->x0+l-2)
	C(m)->u[c]->x0=C(m)->u[c]->x;
      dessiner_ecran(C(m),c,l,h);
      break;

    case E_SORT:
      free(C(m)->u[c]);
      C(m)->u[c]=NULL;
      break;

    case K_LEFT:
      if(C(m)->u[c]->x>0){
	if(--C(m)->u[c]->x<C(m)->u[c]->x0){
	  C(m)->u[c]->x0-=(l-2)>>1;
	  if(C(m)->u[c]->x0<0) C(m)->u[c]->x0=0;
	  dessiner_entree(C(m),c,l,h);
	}else
	  position(c,C(m)->u[c]->x-C(m)->u[c]->x0+1,h-2);
      }
      break;

    case K_RIGHT:
      if(C(m)->u[c]->x<C(m)->u[c]->l){
	if(++C(m)->u[c]->x>C(m)->u[c]->x0+l-2){
	  C(m)->u[c]->x0+=(l-2)>>1;
	  dessiner_entree(C(m),c,l,h);
	}else
	  position(c,C(m)->u[c]->x-C(m)->u[c]->x0+1,h-2);
      }
      break;

    case K_HOME:
      C(m)->u[c]->x=0;
      if(C(m)->u[c]->x0!=0){
	C(m)->u[c]->x0=0;
	dessiner_entree(C(m),c,l,h);
      }else
	position(c,1,h-2);
      break;

    case K_END:
      C(m)->u[c]->x=C(m)->u[c]->l;
      if(C(m)->u[c]->x>=C(m)->u[c]->x0+l-2){
	C(m)->u[c]->x0=C(m)->u[c]->x-2*(l-2)/3;
	dessiner_entree(C(m),c,l,h);
      }else
	position(c,C(m)->u[c]->x-C(m)->u[c]->x0+1,h-2);
      break;

    case K_BACKSPACE:
      if(C(m)->u[c]->x==0)
	break;
      C(m)->u[c]->x--;
    case K_DELETE:
      if(C(m)->u[c]->x==C(m)->u[c]->l)
	break;
      x=C(m)->u[c]->l;
      b=C(m)->u[c]->b;
      for(i=C(m)->u[c]->x+1;i<x;i++)
	b[i-1]=b[i];
      b[i-1]=' ';
      modifier_texte(C(m),c,l,h,C(m)->u[c]->x);
      C(m)->u[c]->l--;
      break;

    case 11:
      x=C(m)->u[c]->l;
      b=C(m)->u[c]->b;
      for(i=C(m)->u[c]->x;i<x;i++)
	b[i]=' ';
      modifier_texte(C(m),c,l,h,C(m)->u[c]->x);
      C(m)->u[c]->l=C(m)->u[c]->x;

    case 13:
      if(C(m)->u[c]->l>0)
	ajouter_message(C(m),c);
      break;

    default:
      if((e>=' ')&&(e<=254)){
	if(C(m)->u[c]->l==MAXMSGLEN)
	  sonner(c);
	else{
	  x=C(m)->u[c]->x++;
	  b=C(m)->u[c]->b;
	  for(i=C(m)->u[c]->l;i>x;i--)
	    b[i]=b[i-1];
	  C(m)->u[c]->l++;
	  b[x]=e;
	  modifier_texte(C(m),c,l,h,x);
	}
      }
      break;
  }
}

static void module_forum_describe(module_info *m,int c,char *b)
{
  strcpy(b,"Module forum");
}

const module_class_info module_forum_class={
  1,0,
  -1L,
  module_forum_new,
  module_forum_destroy,
  module_forum_event,
  module_forum_describe
};
