/****************************************************************************
 * Ce programme fait partie du projet Multiserveur.                         *
 * (C) Nicolas GEORGE, aot 1998.                                           *
 * Vous devriez trouver les termes de sa license pas trs loin.             *
 * Je dcline toute responsabilit quant  l'effet de ce programme.         *
 ****************************************************************************/

/***********************
  Pour jouer  Hexxagon
 ***********************/

#include <malloc.h>
#include <unistd.h>
#include "config.h"
#include "module.h"
#include "events.h"
#include "multiserv.h"

#define INTERVAL 4
#define C(c) ((module_hexxagon_info *)(c))

const module_class_info module_hexxagon_class;

typedef struct {
  module_info mod;
  unsigned char t[169];
  int uj[2];
  char *nuj[2];
  short xc[2];
  short j;
  short x,y,x0,y0;
} module_hexxagon_info;

static const char *hex0g[]={
                   "___",
               "___/   \\___",
           "___/   \\___/   \\___",
       "___/   \\___/   \\___/   \\___",
   "___/   \\___/   \\___/   \\___/   \\___",
  "/   \\___/   \\___/   \\___/   \\___/   \\",
  "\\___/   \\___/   \\___/   \\___/   \\___/",
  "/   \\___/   \\___/   \\___/   \\___/   \\",
  "\\___/   \\___/   \\___/   \\___/   \\___/",
  "/   \\___/   \\___/   \\___/   \\___/   \\",
  "\\___/   \\___/   \\___/   \\___/   \\___/",
  "/   \\___/   \\___/   \\___/   \\___/   \\",
  "\\___/   \\___/   \\___/   \\___/   \\___/",
  "/   \\___/   \\___/   \\___/   \\___/   \\",
  "\\___/   \\___/   \\___/   \\___/   \\___/",
      "\\___/   \\___/   \\___/   \\___/",
          "\\___/   \\___/   \\___/",
              "\\___/   \\___/",
                  "\\___/"
};

static const char hex0j[81]={
  1,0,0,0,2,9,9,9,9,
  0,0,0,0,0,0,9,9,9,
  0,0,0,0,0,0,0,9,9,
  0,0,0,3,0,0,0,0,9,
  2,0,0,0,0,3,0,0,1,
  9,0,0,0,3,0,0,0,0,
  9,9,0,0,0,0,0,0,0,
  9,9,9,0,0,0,0,0,0,
  9,9,9,9,1,0,0,0,2,
};

static module_info *module_hexxagon_new(void)
{
  module_hexxagon_info *r;
  int i;

  r=malloc(sizeof(module_hexxagon_info));
  r->mod.timer=-1;
  r->mod.class=&module_hexxagon_class;
  r->uj[0]=r->uj[1]=-1;
  for(i=0;i<169;i++)
    r->t[i]=9;
  for(i=0;i<81;i++)
    r->t[28+(i%9)+13*(i/9)]=hex0j[i];
  r->j=-4;
  return(&r->mod);
}

static void module_hexxagon_destroy(module_info *m)
{
  if(C(m)->nuj[0]!=NULL)
    free(C(m)->nuj[0]);
  if(C(m)->nuj[1]!=NULL)
    free(C(m)->nuj[1]);
  free(m);
}

static void tracer_case_joueur(module_hexxagon_info *m,int c,int x,int y,int l)
{
  int v;

  if((v=m->t[x+y*13])==9)
    return;
  position(c,((l-51)>>1)+(x<<2),4+(y<<1)-x);
  switch(v){
    case 0:
      attributs(c,0x70);
      ecrire(c,"   ");
      break;
    case 1:
      attributs(c,0x71);
      ecrire(c," o ");
      break;
    case 2:
      attributs(c,0x74);
      ecrire(c," x ");
      break;
    case 3:
      attributs(c,0x00);
      ecrire(c,"###");
      break;
  }
}

static void ecrire_noms(module_hexxagon_info *m,int c,int l)
{
  int i,u;

  if(l<0) l=clipriv[c].l;

  position(c,0,1);
  attributs(c,0x71);
  ecrire_deb(c,MAXNOM-1);
  i=0;
  if((u=m->uj[0])>=0){
    for(;clipriv[u].nom[i]!=0;i++)
      ECRIRE(c,clipriv[u].nom[i]);
  }
  for(;i<MAXNOM-1;i++)
    ECRIRE(c,' ');
  ecrire_fin(c,MAXNOM-1);

  position(c,l-MAXNOM,1);
  attributs(c,0x74);
  ecrire_deb(c,MAXNOM-1);
  i=0;
  if((u=m->uj[1])>=0){
    for(;clipriv[u].nom[i]!=0;i++)
      ECRIRE(c,clipriv[u].nom[i]);
  }
  for(;i<MAXNOM-1;i++)
    ECRIRE(c,' ');
  ecrire_fin(c,MAXNOM-1);
}

static void tracer_case(module_hexxagon_info *m,int x,int y)
{
  tracer_case_joueur(m,m->uj[0],x,y,clipriv[m->uj[0]].l);
  tracer_case_joueur(m,m->uj[1],x,y,clipriv[m->uj[1]].l);
}

static void dessiner_curseur(module_hexxagon_info *m,int x0,int y0,int c)
{
  int j,u,x,y;

  if(c<0){
    if(((m->j&2)!=0)&&(x0==m->x0)&&(y0==m->y0))
      c=1;
    else{
      tracer_case(m,x0,y0);
      return;
    }
  }
  for(j=0;j<2;j++){
    u=m->uj[j];
    attributs(u,(m->j&1)?0x74:0x71);
    x=((clipriv[u].l-51)>>1)+(x0<<2);
    y=4+(y0<<1)-x0;
    position(u,x+2,y);
    ecrire(u,c?"(":"<");
    position(u,x,y);
    ecrire(u,c?")":">");
  }
}

static void tracer_terrain(module_hexxagon_info *m,int c,int l)
{
  int i,j;

  if(l<0) l=clipriv[c].l;
  attributs(c,0x70);
  effacer(c);
  for(i=0;i<19;i++){
    position(c,(l-strlen(hex0g[i]))>>1,1+i);
    ecrire(c,hex0g[i]);
  }
  for(i=2;i<11;i++)
    for(j=2;j<11;j++)
      if((m->t[j+i*13]!=9)&&(m->t[j+i*13]!=0))
	tracer_case_joueur(m,c,j,i,l);

  ecrire_noms(m,c,l);
  attributs(c,0x17);
  position(c,1,20);
  ecrire_n_fois(c,' ',l-2);
  attributs(c,0x47);
  position(c,1,21);
  ecrire_n_fois(c,' ',l-2);

  if((m->j>=0)&&((m->j&(12|1024|2048))==0)){
    if((m->j&2)!=0)
      dessiner_curseur(m,m->x0,m->y0,1);
    dessiner_curseur(m,m->x,m->y,0);
  }
}

static int norme_hexxagon(int x,int y)
{
  if(x<0){
    x=-x;
    y=-y;
  }
  return(y<0?x-y:(x>y?x:y));
}

static void compter_cases(module_hexxagon_info *m)
{
  int i,a=0,b=0,c;
  char s[6]="##\000##";

  for(i=0;i<169;i++){
    if(m->t[i]==1) a++;
    if(m->t[i]==2) b++;
  }
  s[0]=a<10?' ':(a/10)+'0';
  s[1]=(a%10)+'0';
  s[3]=b<10?' ':(b/10)+'0';
  s[4]=(b%10)+'0';
  for(i=0;i<2;i++){
    c=m->uj[i];
    position(c,1,2);
    attributs(c,0x71);
    ecrire(c,s);
    position(c,clipriv[c].l-3,2);
    attributs(c,0x74);
    ecrire(c,s+3);
  }
}

static void hexxagon_evoluer(module_hexxagon_info *m,int t)
{
  if((m->j&12)==0){
    if(t<4){
      int dx,dy;

      dx=(t==1)-(t==0);
      dy=(t==3)-(t==2)+(t==1);
      if(m->t[m->x+dx+(m->y+dy)*13]!=9){
	dessiner_curseur(m,m->x,m->y,-1);
	m->x+=dx;
	m->y+=dy;
	dessiner_curseur(m,m->x,m->y,0);
      }

    }else if((t==4)&&((m->j&2)!=0)){
      dessiner_curseur(m,m->x,m->y,-1);
      m->x=m->x0;
      m->y=m->y0;
      m->x0=0;
      m->y0=0;
      m->j&=~2;
      dessiner_curseur(m,m->x,m->y,0);
    }else if(t==5){
      if((m->j&2)==0){
	if(m->t[m->x+m->y*13]==(m->j&1)+1){
	  m->x0=m->x;
	  m->y0=m->y;
	  m->j|=2;
	  dessiner_curseur(m,m->x,m->y,1);
	}else{
	  sonner(m->uj[m->j&1]);
	}

      }else{
	if((m->t[m->x+m->y*13]==0)&&(norme_hexxagon(m->x-m->x0,m->y-m->y0)<=2)){
	  int dx,dy;

	  if(norme_hexxagon(m->x-m->x0,m->y-m->y0)==2)
	    m->t[m->x0+m->y0*13]=0;
	  m->j&=~2;
	  dessiner_curseur(m,m->x0,m->y0,-1);
	  m->x0=m->y0=0;
	  m->t[m->x+m->y*13]=(m->j&1)+1;
	  dessiner_curseur(m,m->x,m->y,-1);
	  m->j^=1;
	  for(dy=-1;dy<=1;dy++)
	    for(dx=-1;dx<=1;dx++){
	      if(dx+dy==0)
		continue;
	      if(m->t[m->x+dx+(m->y+dy)*13]==(m->j&1)+1){
		m->t[m->x+dx+(m->y+dy)*13]=((m->j&1)^1)+1;
		tracer_case(m,m->x+dx,m->y+dy);
	      }
	    }
	  compter_cases(m);
	  m->x=m->y=6;
	  dessiner_curseur(m,m->x,m->y,0);
	}else{
	  sonner(m->uj[m->j&1]);
	}
      }
    }
  }else if(t==6){
    if(m->y<13){
      while(1){
	if(++m->x==13){
	  m->x=0;
	  if(++m->y==13)
	    break;
	}
	if(m->t[m->x+13*m->y]==0){
	  m->t[m->x+13*m->y]=1+(m->j&1);
	  tracer_case(m,m->x,m->y);
	  compter_cases(m);
	  break;
	}
      }
    }else{
      m->j=8|3;
    }
  }
}

static void module_hexxagon_event(module_info *m,int c,int e,void *p)
{
  int l,h,i,j;

  if(trop_petit(c,60,22,&l,&h))
    return;
  if(e==E_ENTRE){
    if((C(m)->j==-4)||(C(m)->j==-2)){ /* Arrive d'un joueur 1 */
      C(m)->j++;
      C(m)->uj[0]=c;
      C(m)->xc[0]=0;
      if(C(m)->j==-1)
	ecrire_noms(C(m),C(m)->uj[1],-1);
    }else if(C(m)->j==-3){ /* Arrive d'un joueur 2 */
      C(m)->j=-1;
      C(m)->uj[1]=c;
      C(m)->xc[1]=0;
      ecrire_noms(C(m),C(m)->uj[0],-1);
    }else if((C(m)->j>0)&&((C(m)->j&1024)!=0)&&(strcmp(clipriv[c].nom,C(m)->nuj[0])==0)){
      C(m)->j&=~1024;
      C(m)->uj[0]=c;
      free(C(m)->nuj[0]);
      C(m)->nuj[0]=NULL;
      if((C(m)->j&2048)==0)
	message_discret(C(m)->uj[1],"Votre adversaire est revenu");
    }else if((C(m)->j>0)&&((C(m)->j&2048)!=0)&&(strcmp(clipriv[c].nom,C(m)->nuj[1])==0)){
      C(m)->j&=~2048;
      C(m)->uj[1]=c;
      free(C(m)->nuj[1]);
      C(m)->nuj[1]=NULL;
      if((C(m)->j&1024)==0)
	message_discret(C(m)->uj[0],"Votre adversaire est revenu");
    }
    tracer_terrain(C(m),c,l);
    return;
  }
  if(e==RIEN){
    if((C(m)->j&(1024|2048))==0)
      hexxagon_evoluer(C(m),6);
    m->timer=(C(m)->j&8)==0?INTERVAL:-1;
  }
  if(c==C(m)->uj[0]) j=0;
  else if(c==C(m)->uj[1]) j=1;
  else j=2;
  if(e==TAILLE){
    tracer_terrain(C(m),c,l);
    if(j<2) C(m)->xc[j]=0;
    return;
  }
  if(j==2) return;
  if(((e>=' ')&&(e<=254))||(e==K_BACKSPACE)||(e==11)){
    if((C(m)->j<-1)||((C(m)->j>=0)&&((C(m)->j&(1024|2048))!=0)))
      return;
    if((e==K_BACKSPACE)&&(C(m)->xc[j]>0)){
      C(m)->xc[j]--;
      for(i=0;i<2;i++){
	if(C(m)->xc[j]<clipriv[C(m)->uj[i]].l-2){
	  attributs(C(m)->uj[i],j?0x47:0x17);
	  position(C(m)->uj[i],1+C(m)->xc[j],20+j);
	  ecrire(C(m)->uj[i]," ");
	  position(C(m)->uj[i],1+C(m)->xc[j],20+j);
	}
      }
    }else if((e>=' ')&&(e<=254)){
      if((C(m)->xc[j]<clipriv[C(m)->uj[0]].l-2)&&
	 (C(m)->xc[j]<clipriv[C(m)->uj[1]].l-2)){
	for(i=0;i<2;i++){
	  attributs(C(m)->uj[i],j?0x47:0x17);
	  position(C(m)->uj[i],1+C(m)->xc[j],20+j);
	  ecrire_n_fois(C(m)->uj[i],e,1);
	}
	C(m)->xc[j]++;
      }else
	sonner(c);
    }else if(e==11){
	for(i=0;i<2;i++){
	  attributs(C(m)->uj[i],j?0x47:0x17);
	  position(C(m)->uj[i],1,20+j);
	  ecrire_n_fois(C(m)->uj[i],' ',clipriv[C(m)->uj[i]].l-2);
	  position(C(m)->uj[i],1,20+j);
	}
	C(m)->xc[j]=0;
    }
  }else if(C(m)->j<0){
    if(e==E_SORT){
      C(m)->uj[j]=-1;
      C(m)->j-=(1<<j);
      if(C(m)->j==-4){
	detruire_module_ptr(m);
	return;
      }
      if(C(m)->uj[0]>=0)
	ecrire_noms(C(m),C(m)->uj[0],-1);
      if(C(m)->uj[1]>=0)
	ecrire_noms(C(m),C(m)->uj[1],-1);
    }else if(e==9){
      i=C(m)->uj[0];
      C(m)->uj[0]=C(m)->uj[1];
      C(m)->uj[1]=i;
      C(m)->j=-4+(C(m)->uj[0]>=0)+2*(C(m)->uj[1]>=0);
      if(C(m)->uj[0]>=0)
	ecrire_noms(C(m),C(m)->uj[0],-1);
      if(C(m)->uj[1]>=0)
	ecrire_noms(C(m),C(m)->uj[1],-1);
    }else if((e==13)&&(C(m)->j==-1)){
      C(m)->j=0;
      C(m)->x=C(m)->y=6;
      C(m)->x0=C(m)->y0=-1;
      dessiner_curseur(C(m),C(m)->x,C(m)->y,0);
    }
  }else{
    if(e==E_SORT){
      if((C(m)->j&8)==0){
	C(m)->nuj[j]=malloc(MAXNOM);
	strcpy(C(m)->nuj[j],clipriv[C(m)->uj[j]].nom);
	C(m)->j|=1024<<j;
	if((C(m)->j&(2048>>j))==0)
	  message_discret(C(m)->uj[1-j],"Votre adversaire s'absente");
      }else{
	if(C(m)->j!=8){
	  C(m)->j&=~(1<<j);
	  if(C(m)->j==8)
	    detruire_module_ptr(m);
	}
      }
    }else if(((e==K_LEFT)||(e==K_RIGHT)||(e==K_UP)||(e==K_DOWN)||
	     (e==K_DELETE)||(e==9)||(e==13))&&(j==(C(m)->j&~2))){
      hexxagon_evoluer(C(m),e==K_LEFT?0:(e==K_RIGHT?1:e==K_UP?2:
		       (e==K_DOWN?3:(((e==K_DELETE)||(e==9))?4:5))));
    }else if((e==3)&&(j==(C(m)->j&~2))){
      C(m)->j|=4;
      C(m)->j^=1;
      C(m)->x=-1;
      C(m)->y=0;
      m->timer=INTERVAL;
    }
  }
}

static void module_hexxagon_describe(module_info *m,int c,char *b)
{
  strcpy(b,"Partie d'Hexxagon");
}

const module_class_info module_hexxagon_class={
  0,1, /*  changer */
  600L,
  module_hexxagon_new,
  module_hexxagon_destroy,
  module_hexxagon_event,
  module_hexxagon_describe
};
