/****************************************************************************
 * Ce programme fait partie du projet Multiserveur.                         *
 * (C) Nicolas GEORGE, aot 1998.                                           *
 * Vous devriez trouver les termes de sa license pas trs loin.             *
 * Je dcline toute responsabilit quant  l'effet de ce programme.         *
 ****************************************************************************/

/*******************************
  Le module liste des modules
 *******************************/

#include <malloc.h>
#include <unistd.h>
#include "config.h"
#include "module.h"
#include "events.h"
#include "multiserv.h"

const module_class_info module_liste_class;

typedef struct {
  int x,x0,nlp,*lp,nv;
} module_liste_utilisateur_info;

typedef struct {
  module_info mod;
  module_liste_utilisateur_info util[MAXCLI];
} module_liste_info;

static module_info *module_liste_new(void)
{
  module_liste_info *r;
  int i;

  r=malloc(sizeof(module_liste_info));
  r->mod.timer=-1;
  r->mod.class=&module_liste_class;
  for(i=0;i<MAXCLI;i++){
    r->util[i].x=r->util[i].x0=0;
    r->util[i].lp=NULL;
  }
  return(&r->mod);
}

static void module_liste_destroy(module_info *m)
{
  free(m);
}

static void afficher_liste(int c,int l,int h,module_liste_utilisateur_info *v)
{
  int i,j,k,y;
  char b[80];

  if(v->lp!=NULL)
    free(v->lp);
  for(i=j=0;i<nbr_pieces;i++)
    if(pieces[i]!=NULL)
      j++;
  for(i=0;i<nbr_modules;i++)
    if(modules[i]->plusieurs)
      j++;
  j++;
  v->lp=malloc(j*sizeof(int));
  for(i=j=0;i<nbr_pieces;i++)
    if(pieces[i]!=NULL)
      v->lp[j++]=i;
  for(i=0;i<nbr_modules;i++)
    if(modules[i]->plusieurs)
      v->lp[j++]=~i;
  v->nlp=j;

  if(v->x>=v->nlp) v->x=v->nlp-1;
  if(v->x0>v->x) v->x0=v->x;

  y=(2*h)/3;
  attributs(c,0x70);
  effacer(c);
  position(c,0,y);
  ecrire_n_fois(c,'-',l);

  j=1;
  for(i=0,k=v->x0;(i<y-1)&&(k<v->nlp);i++,k++){
    if(v->lp[k]>=0){
      if(pieces[v->lp[k]]==NULL)
	strcpy(b,"<dtruite>");
      else
	pieces[v->lp[k]]->class->describe(pieces[v->lp[k]],c,b);
    }else{
      if(j)
	attributs(c,0x71);
      j=0;
      strcpy(b,"Nouveau module: ");
      modules[~v->lp[k]]->describe(NULL,c,b+16);
    }
    position(c,2,i+1);
    ecrire_max(c,b,l-2);
  }
}

static void selectionner_module(int c,int l,int h,module_liste_utilisateur_info *v)
{
  int y,i,j,k;

  attributs(c,0x70);
  y=(2*h)/3;
  if(v->x-v->x0==y-1){
    v->x0=v->x;
    afficher_liste(c,l,h,v);
  }
  if(v->x<v->x0){
    v->x0-=y-1;
    if(v->x0<0) v->x0=0;
    afficher_liste(c,l,h,v);
  }
  if(v->lp[v->x]>=0){
    k=l/MAXNOM;
    for(i=j=0;i<MAXCLI;i++)
      if(clipriv[i].mod==v->lp[v->x]){
	position(c,(j%k)*MAXCLI,y+1+j/k);
	ecrire(c,clipriv[i].nom);
	j++;
      }
    v->nv=j;
  }
  position(c,0,1+v->x-v->x0);
  ecrire_n_fois(c,'>',1);
}

static void deselectionner_module(int c,int l,int h,module_liste_utilisateur_info *v)
{
  int y,i,k;

  attributs(c,0x70);
  if(v->lp[v->x]>=0){
    y=(2*h)/3;
    k=l/MAXNOM;
    for(i=0;i<v->nv;i++){
      position(c,(i%k)*MAXCLI,y+1+i/k);
      ecrire_n_fois(c,' ',MAXNOM-1);
    }
  }
  position(c,0,1+v->x-v->x0);
  ecrire_n_fois(c,' ',1);
}

static void module_liste_event(module_info *m,int c,int e,void *p)
{
  int i,l,h;
  module_liste_info *m2;

  m2=(module_liste_info *)m;
  if(trop_petit(c,40,15,&l,&h))
    return;
  switch(e){
    case E_ENTRE:
      m2->util[c].x=m2->util[c].x0=0;
      /* pas de break */
    case TAILLE:
      afficher_liste(c,l,h,&m2->util[c]);
      selectionner_module(c,l,h,&m2->util[c]);
      break;
    case E_SORT:
      if(m2->util[c].lp!=NULL)
	free(m2->util[c].lp);
      m2->util[c].lp=NULL;
      break;
    case K_DOWN:
      if(m2->util[c].x==m2->util[c].nlp-1)
	break;
      deselectionner_module(c,l,h,&m2->util[c]);
      m2->util[c].x++;
      selectionner_module(c,l,h,&m2->util[c]);
      break;
    case K_UP:
      if(m2->util[c].x==0)
	break;
      deselectionner_module(c,l,h,&m2->util[c]);
      m2->util[c].x--;
      selectionner_module(c,l,h,&m2->util[c]);
      break;
    case 13:
      i=m2->util[c].lp[m2->util[c].x];
      if(i>=0){
	if(pieces[i]!=NULL){
	  if(pieces[i]!=m)
	    changer_module(c,i);
	}else{
	  afficher_liste(c,l,h,&m2->util[c]);
	  selectionner_module(c,l,h,&m2->util[c]);
	}
      }else{
	i=creer_module(~i);
	if(i>=0)
	  changer_module(c,i);
	else
	  message_discret(c,"Cration impossible");
      }
      break;
    case 18:
      afficher_liste(c,l,h,&m2->util[c]);
      selectionner_module(c,l,h,&m2->util[c]);
      break;
  }
}

static void module_liste_describe(module_info *m,int c,char *b)
{
  strcpy(b,"Liste de modules");
}

const module_class_info module_liste_class={
  1,0,
  -1L,
  module_liste_new,
  module_liste_destroy,
  module_liste_event,
  module_liste_describe
};
