/****************************************************************************
 * Ce programme fait partie du projet Multiserveur.                         *
 * (C) Nicolas GEORGE, aot 1998.                                           *
 * Vous devriez trouver les termes de sa license pas trs loin.             *
 * Je dcline toute responsabilit quant  l'effet de ce programme.         *
 ****************************************************************************/

/* Un module est un pointeur vers un bloc de mmoire commenant par un
   objet module_info. Le pointeur est pass tel quel, sans aucune modifi-
   cation. */

typedef struct {
  int timer;
  long t_mort;
  const struct _module_class_info *class;
} module_info;

typedef struct _module_class_info {

  /* Un exemplaire du module doit-il tre cr au dbut ? */
  int au_debut:1;

  /* Peut-on crer de nouvelles instances ? */
  int plusieurs:1;

  /* Dure de vie en secondes */
  long vie;

  /* Cre un nouvel exemplaire du module */
  module_info *(*new)(void);

  /* Dtruit cet exemplaire du module */
  void (*destroy)(module_info *);

  /* Raction  un vnement */
  void (*event)(module_info *,int,int,void *);

  /* Dcrit le module dans le buffer pass */
  void (*describe)(module_info *,int,char *);

} module_class_info;

extern const module_class_info *modules[];
extern const int nbr_modules;
extern module_info **pieces;
extern int nbr_pieces;
void detruire_module_ptr(module_info *m);
