/****************************************************************************
 * Ce programme fait partie du projet Multiserveur.                         *
 * (C) Nicolas GEORGE, aot 1998.                                           *
 * Vous devriez trouver les termes de sa license pas trs loin.             *
 * Je dcline toute responsabilit quant  l'effet de ce programme.         *
 ****************************************************************************/

/*******************
  Boucle principale
 *******************/

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include "config.h"
#include "module.h"
#include "multiserv.h"
#include "connect.h"
#include "guichet.h"
#include "events.h"

echange_client *client;
parametres_client *clipriv;
module_info **pieces;
int nbr_pieces;
char *ph_bienvenue=NULL;
static pid_t connect;
static key_t shmseg;
static short loop=1;

static void gestion_signaux(int s)
{
  pid_t p;
  int e,i;

  signal(s,gestion_signaux);
  switch(s){
    case SIGCHLD:
      p=waitpid(-1,&e,WNOHANG);
      if(p){

	if((!WIFEXITED(e))||(WEXITSTATUS(e))){
	  lprintf("Mort du fils %d, ",(int)p);
	  if(WIFEXITED(e))
	    lprintf("retour %d\n",WEXITSTATUS(e));
	  else if(WIFSIGNALED(e))
	    lprintf("tu par %d\n",WTERMSIG(e));
	}
	if(p==connect){
	  loop=connect=0;
	  lprintf("Fermeture du port.\n");
	}

	for(i=0;i<MAXCLI;i++)
	  if(p==client[i].pid){
	    lprintf("Dconnexion de %d\n",i);
	    envoyer_touche(i,FIN);
	    break;
	  }
      }
      break;
    case SIGINT:
    case SIGTERM:
      loop=0;
      break;
  }
}

static void preparer_clients(void)
{
  int i;

  for(i=0;i<MAXCLI;i++)
    reinitialiser_client(i);
}

void preparer_client_prive(int i)
{
  int j;

  clipriv[i].mod=-1;
  clipriv[i].wrpos=0;
  for(j=0;j<MAXNOM;j++)
    clipriv[i].nom[j]=0;
}

void preparer_clients_prives(void)
{
  int i;

  for(i=0;i<MAXCLI;i++)
    preparer_client_prive(i);
}

static int lire_touche(int c)
{
  int r=RIEN;

  if(client[c].keys){
    r=client[c].key[client[c].keyt++];
    client[c].keyt%=KEY_BUF_SIZE;
    client[c].keys--;
  }
  return(r);
}

void envoyer_message(int m,int c,int e,void *d)
{
  pieces[m]->class->event(pieces[m],c,e,d);
}

void tester_vide(int m)
{
  int j;

  if(pieces[m]==NULL)
    return;
  for(j=0;j<MAXCLI;j++)
    if(clipriv[j].mod==m)
      return;
  if(pieces[m]->class->vie<0)
    pieces[m]->t_mort=-1L;
  else
    pieces[m]->t_mort=time(NULL)+pieces[m]->class->vie;
}

void changer_module(int c,int m)
{
  int i;

  i=clipriv[c].mod;
  if(i>=0)
    envoyer_message(i,c,E_SORT,NULL);
  clipriv[c].mod=m;
  if(i>=0)
    tester_vide(i);
  pieces[m]->t_mort=-1L;
  envoyer_message(m,c,E_ENTRE,NULL);
}

static void touche_login(int c,int t)
{
  int l,h,x,y,i;

  if(trop_petit(c,40,12,&l,&h))
    return;
  if(t==TAILLE){
    attributs(c,0x00);
    attributs(c,0x70);
    effacer(c);
    /* C'est cette notice qui doit rester intacte si vous tes lve  l'X */
    position(c,l-26,h-2);
    ecrire(c,"Multiserver, (C) N. GEORGE");
    position(c,l-26,h-1);
    ecrire(c,"nicolas.george@ens.fr");
    /* Voil, c'est pas beaucoup... */
    /* Si la restriction ne s'applique pas  vous et que vous voulez l'enlever,
       SVP, contentez-vous de commenter ces 4 lignes */
    x=(l-30)>>1;
    attributs(c,0x07);
    position(c,x,1);
    ecrire_n_fois(c,' ',30);
    position(c,x,2);
    ecrire(c,"   Bienvenue sur le serveur   ");
    position(c,x,3);
    ecrire(c,"      de Nicolas GEORGE       ");
    position(c,x,4);
    ecrire_n_fois(c,' ',30);

    message_discret(c,ph_bienvenue);

    y=(h+1)>>1;
    x=(l-MAXNOM+1)>>1;
    attributs(c,0x70);
    position(c,x,y-1);
    ecrire(c,"Votre nom:");
    attributs(c,0x30);
    position(c,x,y);
    ecrire_deb(c,MAXNOM-1);
    for(i=0;i<MAXNOM-1;i++)
      ECRIRE(c,clipriv[c].nom[i]==0?' ':clipriv[c].nom[i]);
    ecrire_fin(c,MAXNOM-1);
    for(i=0;clipriv[c].nom[i]!=0;i++) x++;
    position(c,x,y);
    return;
  }
  if(t==4){
    virer_client(c);
    return;
  }
  if(t==FIN){
    reinitialiser_client(c);
    return;
  }
  for(i=0;clipriv[c].nom[i]!=0;i++);
  y=(h+1)>>1;
  x=((l-MAXNOM+1)>>1)+i;
  if((t>=32)&&(t<255)&&(i<MAXNOM-1)){
    position(c,x,y);
    attributs(c,0x30);
    ecrire_n_fois(c,t,1);
    clipriv[c].nom[i]=t;
  }else if((t==K_BACKSPACE)&&(i>0)){
    clipriv[c].nom[--i]=0;
    position(c,--x,y);
    attributs(c,0x30);
    ecrire(c," ");
    position(c,x,y);
  }else if((t==13)&&(i>0)){
    char b[MAXNOM+12];

    for(i=0;i<MAXCLI;i++)
      if((i!=c)&&(clipriv[i].mod>=0)&&(strcmp(clipriv[i].nom,clipriv[c].nom)==0)){
	message_discret(c,"Dj pris.");
	sonner(c);
	return;
      }
    lprintf("Numro %d prend le nom \"%s\"\n",c,clipriv[c].nom);
    strcpy(b,clipriv[c].nom);
    strcat(b," est arriv.");
    for(i=0;i<MAXCLI;i++)
      if(clipriv[i].mod>=0)
	message_discret(i,b);
    changer_module(c,0);
  }
}

static void interpreter_touche(int c,int t)
{
  if(t==4){
    virer_client(c);
    return;
  }else if(t==17){
    changer_module(c,0);
  }else if(t==FIN){
    char b[MAXNOM+12];
    int i;

    envoyer_message(clipriv[c].mod,c,E_SORT,NULL);
    strcpy(b,clipriv[c].nom);
    strcat(b," est parti.");
    for(i=0;i<MAXCLI;i++)
      if(clipriv[i].mod>=0)
	message_discret(i,b);
    reinitialiser_client(c);
    preparer_client_prive(c);
  }else{
    envoyer_message(clipriv[c].mod,c,t,NULL);
  }
}

int creer_module(int nm)
{
  int i;
  const module_class_info *m;

  m=modules[nm];
  for(i=0;i<nbr_pieces;i++)
    if(pieces[i]==NULL)
      break;
  if(i==nbr_pieces){
    int j;

    nbr_pieces+=nbr_modules;
    pieces=realloc(pieces,nbr_pieces*sizeof(module_info *));
    for(j=i;j<nbr_pieces;j++)
      pieces[j]=NULL;
  }
  pieces[i]=m->new();
  if(pieces[i]==NULL)
    lprintf("Echec de la cration d'un module %d\n",nm);
  else
    lprintf("Cration d'un module %d sous le numro %d\n",nm,i);
  return(pieces[i]!=NULL?i:-1);
}

void detruire_module(int n)
{
  int i;

  for(i=0;i<MAXCLI;i++)
    if(clipriv[i].mod==n)
      changer_module(i,0);
  pieces[n]->class->destroy(pieces[n]);
  pieces[n]=NULL;
  lprintf("Destruction du module %d\n",n);
}

void detruire_module_ptr(module_info *m)
{
  int i;

  for(i=0;i<nbr_pieces;i++)
    if(pieces[i]==m)
      detruire_module(i);
}

static void initialiser_modules(void)
{
  int i;

  nbr_pieces=nbr_modules;
  pieces=malloc(nbr_pieces*sizeof(module_info *));
  for(i=0;i<nbr_pieces;i++)
    pieces[i]=NULL;
  for(i=0;i<nbr_modules;i++)
    if(modules[i]->au_debut)
      creer_module(i);
}

static void boucle_principale(void)
{
  int i,j,tt=0;

  signal(SIGINT,gestion_signaux);
  signal(SIGTERM,gestion_signaux);

  initialiser_modules();

  while(loop){
    usleep(10000);
    for(i=0;i<MAXCLI;i++){
      if(client[i].pid==0)
	continue;
      if((j=lire_touche(i))!=RIEN){
	if(j==TAILLE){
	  do clipriv[i].l=lire_touche(i);
	  while(clipriv[i].l==RIEN);
	  do clipriv[i].h=lire_touche(i);
	  while(clipriv[i].h==RIEN);
	}
	if(clipriv[i].mod==-1)
	  touche_login(i,j);
	else
	  interpreter_touche(i,j);
      }
    }

    surveiller_commandes();

    for(i=0;i<nbr_pieces;i++)
      if(pieces[i]!=NULL)
	if(pieces[i]->timer>0)
	  if(--(pieces[i]->timer)==0)
	    envoyer_message(i,-1,RIEN,NULL);

    if(++tt==20){
      long t;

      tt=0;
      t=time(NULL);
      for(i=0;i<nbr_pieces;i++)
	if((pieces[i]!=NULL)&&(pieces[i]->t_mort>0)&&(pieces[i]->t_mort<t))
	  detruire_module(i);
    }
  }
  for(i=0;i<MAXCLI;i++)
    if(client[i].pid!=0)
      message_discret(i,PHRASE_ETEINDRE);
  usleep(200000);
  for(i=0;i<MAXCLI;i++)
    if(client[i].pid!=0)
      virer_client(i);
  usleep(50000);
  kill(connect,SIGTERM);
  for(i=0;i<500;i++){
    if(connect==0)
      return;
    usleep(1000);
  }
  lprintf("Destruction du port.\n");
  kill(connect,SIGINT);
}

int main(void)
{
  signal(SIGCHLD,gestion_signaux);
  shmseg=shmget(IPC_PRIVATE,MAXCLI*sizeof(echange_client),S_IREAD|S_IWRITE);
  client=(echange_client *)shmat(shmseg,NULL,0);
  preparer_clients();
  initialiser_superviseur();
  connect=fork();

  if(connect==0){
    boucle_attente_connexions();
    return(0);
  }

  clipriv=malloc(MAXCLI*sizeof(parametres_client));
  preparer_clients_prives();

  ph_bienvenue=malloc(200);
  strcpy(ph_bienvenue,PHRASE_ACCUEIL);
  boucle_principale();
  shmctl(shmseg,IPC_RMID,NULL);
  lprintf("Arrt du serveur\n");
  return(0);
}
