/****************************************************************************
 * Ce programme fait partie du projet Multiserveur.                         *
 * (C) Nicolas GEORGE, aot 1998.                                           *
 * Vous devriez trouver les termes de sa license pas trs loin.             *
 * Je dcline toute responsabilit quant  l'effet de ce programme.         *
 ****************************************************************************/

/****************************************
  Fonctions de sortie vers les terminaux
 ****************************************/

#include <unistd.h>
#include "config.h"
#include "guichet.h"
#include "multiserv.h"

inline int bloquer(int c,int n)
{
  /* Un autre timeout */
  n=INSTR_BUF_SIZE-n;
  while(client[c].inss>n)
    usleep(1000);
  return(0);
}

void inline ecrire_deb(int c,int n)
{
  bloquer(c,n+2);
  ECRIRE(c,P_PRINT);
}

void inline ecrire_fin(int c,int n)
{
  ECRIRE(c,0);
  client[c].inss+=n+2;
}

void effacer(int c)
{
  bloquer(c,1);
  client[c].ins[client[c].insh++]=P_CLEAR;
  client[c].insh%=INSTR_BUF_SIZE;
  client[c].inss++;
}

void attributs(int c,int a)
{
  bloquer(c,2);
  client[c].ins[client[c].insh++]=P_ATTR;
  client[c].insh%=INSTR_BUF_SIZE;
  client[c].ins[client[c].insh++]=a;
  client[c].insh%=INSTR_BUF_SIZE;
  client[c].inss+=2;
}

void position(int c,int x,int y)
{
 bloquer(c,4);
  x+=y<<12;
  client[c].ins[client[c].insh++]=P_LOCATE;
  client[c].insh%=INSTR_BUF_SIZE;
  client[c].ins[client[c].insh++]=x&255;
  client[c].insh%=INSTR_BUF_SIZE;
  client[c].ins[client[c].insh++]=(x>>8)&255;
  client[c].insh%=INSTR_BUF_SIZE;
  client[c].ins[client[c].insh++]=x>>16;
  client[c].insh%=INSTR_BUF_SIZE;
  client[c].inss+=4;
}

void ecrire(int c,const char *s)
{
  int i;

  for(i=0;s[i]!=0;i++);
  i+=2;
  bloquer(c,i);
  client[c].ins[client[c].insh++]=P_PRINT;
  client[c].insh%=INSTR_BUF_SIZE;
  for(;*s!=0;s++){
    client[c].ins[client[c].insh++]=*s;
    client[c].insh%=INSTR_BUF_SIZE;
  }
  client[c].ins[client[c].insh++]=0;
  client[c].insh%=INSTR_BUF_SIZE;
  client[c].inss+=i;
}

void ecrire_max(int c,char *s,int l)
{
  int i;

  for(i=0;(s[i]!=0)&&(i<l);i++);
  i+=2;
  bloquer(c,i);
  client[c].ins[client[c].insh++]=P_PRINT;
  client[c].insh%=INSTR_BUF_SIZE;
  for(;(*s!=0)&&(l>0);s++,l--){
    client[c].ins[client[c].insh++]=*s;
    client[c].insh%=INSTR_BUF_SIZE;
  }
  client[c].ins[client[c].insh++]=0;
  client[c].insh%=INSTR_BUF_SIZE;
  client[c].inss+=i;
}

void sonner(int c)
{
  bloquer(c,1);
  client[c].ins[client[c].insh++]=P_BEEP;
  client[c].insh%=INSTR_BUF_SIZE;
  client[c].inss++;
}

void virer_client(int c)
{
  bloquer(c,1);
  client[c].ins[client[c].insh++]=P_SHUT;
  client[c].insh%=INSTR_BUF_SIZE;
  client[c].inss++;
}

void ecrire_n_fois(int c,char v,int n)
{
  int i;

  ecrire_deb(c,n);
  for(i=0;i<n;i++) ECRIRE(c,v);
  ecrire_fin(c,n);
}

void message_discret(int c,char *m)
{
  int i,l;

  l=clipriv[c].l;
  position(c,0,0);
  attributs(c,0x70);
  ecrire_deb(c,l);
  for(i=0;(i<l)&&(*m!=0);i++,m++) ECRIRE(c,*m);
  for(;i<l;i++) ECRIRE(c,' ');
  ecrire_fin(c,l);
}

int trop_petit(int c,int l,int h,int *lr,int *hr)
{
  if(((*lr=clipriv[c].l)<l)||
     ((*hr=clipriv[c].h)<h)){
    effacer(c);
    ecrire(c,"Agrandissez votre terminal");
    sonner(c);
    return(1);
  }
  return(0);
}
